/* FONTINST.CMD for compatibility fonts */

x = setlocal()

echo = '@'

i = 1
typ.i = CODEDFONTS;    typreq.i = NO; i = i + 1
typ.i = COMPAT240;     typreq.i = NO; i = i + 1
typ.i = COMPAT300;     typreq.i = NO; i = i + 1
typ.i = ALL;           typreq.i = NO
tottypes = i

source = '.'

ARG commandline

if WORDS(commandline) <> 0 then do
  if WORDS(commandline) < 2 then do
    targetdrv = WORD(commandline, 1)
    fontset.1 = ALL
    totfont = 1
  end
  else do
    if WORDS(commandline) < 7 then do
      targetdrv = WORD(commandline, 1)
      do i = 2 to WORDS(commandline)
        if WORDS(commandline) >= i then do
          j = i - 1
          fontset.j = WORD(commandline, i)
        end
      end
      totfont = WORDS(commandline) - 1
    end
    else do
      CALL HELP;
    end
  end
end
else do
  CALL HELP;
end

if POS(':', targetdrv) <> 2 then do
  CALL HELP;
end
drvlet = SUBSTR(targetdrv, 1, 1)
if POS(drvlet, 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz') = 0 then do
  CALL HELP;
end
if LENGTH(targetdrv) <> 2 then do
  CALL HELP;
end

targetdir = targetdrv || '\PSF2RES'

say '*********************************************************'
say '* PSF/2 tHĝɎgpłn[hEhCu'
say '* Xy[X\ɂ邱ƂmFĂB'
say '* PSF/2 tHgEIvV̓𑱍sɂ́A'
say '* <enter> ĂB~ɂ́A<Ctl-C> '
say '* ĂBJnœ~ɂ́A'
say '* A<Ctl-C> Ȃ΂ȂȂꍇ܂B'
say '*********************************************************'
parse upper pull dummy

echo || 'md 'targetdir

if rc <> 0 then do
  call RxFuncAdd 'SysMkDir', 'RexxUtil', 'SysMkDir'
  ret_code = SysMkDir(targetdir)
  if ret_code <> 5 then do
    EXIT;
  end
end

do i = 1 to totfont
  matchfound = NO
  do j = 1 by 1 while SYMBOL('typ.j') = 'VAR'
    if fontset.i = typ.j then do
      matchfound = YES
      typreq.j = YES
      leave
    end
  end
  if matchfound = NO then do
    CALL HELP;
  end
end

say '*********************************************************'
say '* sfBNg[fBNg[ 'targetdir' '
say '* PSF/2 2.00 tHgEt@C]łB'
say '* fBNg[͂łɑ݂邪At@CȂꍇA'
say '* G[EbZ[Wo܂B̃bZ[W͖'
say '* ĂB~ɂ́A<Ctl-C> ĂB'
say '* ~OɁA<Ctl-C> Kvꍇ'
say '* ܂B'
say '*********************************************************'

echo || 'md 'targetdir'\FONTC240'
echo || 'md 'targetdir'\FONTC300'
echo || 'md 'targetdir'\CODEFONT'
echo || 'md 'targetdir'\CODEPAGE'
echo || 'md 'targetdir'\CODEPAGE\PRIMARY'
echo || 'md 'targetdir'\CODEPAGE\SECONDRY'

echo || 'attrib -r 'targetdir'\*.* /s'
if rc <> 0 then do
  if rc <> 2 then do
    EXIT;
  end
end

font240d = NO
font300d = NO
codefontd = NO
codepaged = NO
do i = 1 to tottypes
  if typreq.i = YES then do
    select
      when typ.i = CODEDFONTS then do
        echo || '.\loadram2 'source'\COMPCF.FLS 'targetdir'\CODEFONT\ /D'
        codefontd = YES
      end
      when typ.i = COMPAT240 then do
        echo || '.\loadram2 'source'\COMPC240.FLS 'targetdir'\FONTC240\ /D'
        echo || '.\loadram2 'source'\PRIMARY.FLS 'targetdir'\CODEPAGE\PRIMARY\ /D'
        echo || '.\loadram2 'source'\SECONDRY.FLS 'targetdir'\CODEPAGE\SECONDRY\ /D'
        font240d = YES
        codepaged = YES
      end
      when typ.i = COMPAT300 then do
        echo || '.\loadram2 'source'\COMPC300.FLS 'targetdir'\FONTC300\ /D'
        echo || '.\loadram2 'source'\PRIMARY.FLS 'targetdir'\CODEPAGE\PRIMARY\ /D'
        echo || '.\loadram2 'source'\SECONDRY.FLS 'targetdir'\CODEPAGE\SECONDRY\ /D'
        font300d = YES
        codepaged = YES
      end
      when typ.i = ALL then do
        echo || '.\loadram2 'source'\COMPCF.FLS 'targetdir'\CODEFONT\ /D'
        echo || '.\loadram2 'source'\COMPC240.FLS 'targetdir'\FONTC240\ /D'
        echo || '.\loadram2 'source'\COMPC300.FLS 'targetdir'\FONTC300\ /D'
        echo || '.\loadram2 'source'\PRIMARY.FLS 'targetdir'\CODEPAGE\PRIMARY\ /D'
        echo || '.\loadram2 'source'\SECONDRY.FLS 'targetdir'\CODEPAGE\SECONDRY\ /D'
        font240d = YES
        font300d = YES
        codefontd = YES
        codepaged = YES
      end
      otherwise
        say 'vOɖ肪܂BPSF/2 T[rXɘAĂB'
    end
  end
end

targetdrv
echo || 'cd 'targetdir

say '*********************************************************'
say '* CuA PSF/2 2.00 tHgǉłB'
say '* ~ɂ́A<Ctl-C> ĂB'
say '*********************************************************'

if font240d = YES then do
  echo || 'cd .\FONTC240'
  echo || 'RLADD R *.* * /R /L > ..\FONT240.LOG'
  echo || 'cd ..'
end

if font300d = YES then do
  echo || 'cd .\FONTC300'
  echo || 'RLADD R *.* * /R /L > ..\FONT300.LOG'
  echo || 'cd ..'
end

if codefontd = YES then do
  echo || 'cd .\CODEFONT'
  echo || 'RLADD R *.* * /R /L > ..\FONTCF.LOG'
  echo || 'cd ..'
end

if codepaged = YES then do
  echo || 'cd .\CODEPAGE\PRIMARY'
  echo || 'RLADD R *.* * /R /L > ..\..\FONTPRI.LOG'
  echo || 'cd ..\SECONDRY'
  echo || 'RLADD R *.* * /R /L > ..\..\FONTSEC.LOG'
  echo || 'cd ..\..'
end

say '*********************************************************'
say '* tHg͒ǉ܂BڍׂɂẮA'
say '* 'targetdir'\FONT*.LOG t@CĂB'
say '*********************************************************'

x = endlocal()
CALL QUIT;

HELP:;
  say '**************************************************************';
  say '* ̓R}h́APSF/2 t@C             *';
  say '* fBNg[sȂ΂Ȃ܂B               *';
  say '*                                                            *';
  say '* ̓R}hɂ́Ap[^[PKvłB         *';
  say '*                                                            *';
  say '* `:                                                      *';
  say '*   FONTINST <target drive> <fonts>                          *';
  say '*                                                            *';
  say '* :                                                      *';
  say '*   <target drive>  PSF/2 hCułB       *';
  say '*     ̃hCúAPUTDIR R}hgpƂ        *';
  say '*     PSF/2 t@CꎞIɕۊǂhCuł           *';
  say '*     ܂B́AK{p[^[łB             *';
  say '*   <fonts> ́ÂꂩA܂ׂ͂ĂłB             *';
  say '*     ALL (ȗl)                                         *';
  say '*     CODEDFONTS                                             *';
  say '*     COMPAT240                                              *';
  say '*     COMPAT300                                              *';
  say '* :                                                        *';
  say '*   fontinst c: all                                          *';
  say '*                                                            *';
  say '* tHǵAfBNg[ \PSF2RES ɓ܂B       *';
  say '* tHgEfBNg[ɂ鑼̃tHǵA             *';
  say '* CuAɒǉ܂B                         *';
  say '**************************************************************';
  x = endlocal()
  CALL QUIT;
RETURN;

QUIT:;
EXIT;
